#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

int bgmtable[21][3]={
	{0x000010, 0xf1ad0, 0xc20510},
	{0xc20510, 0xccb310, 0x222f010},
	{0x222f010, 0x24d7010, 0x2f4f010},
	{0x2f4f010, 0x2fc5f10, 0x487c010},
	{0x487c010, 0x4cc9690, 0x58ad110},
	{0x58ad110, 0x5b4a310, 0x6835110},
	{0x6835110, 0x6cbf710, 0x7b77b10},
	{0x7b77b10, 0x7cdc610, 0x8b7fb10},
	{0x8b7fb10, 0x8dba610, 0xa717b10},
	{0xa717b10, 0xa8d2710, 0xbc69b10},
	{0xbc69b10, 0xbd89610, 0xd9c4410},
	{0xd9c4410, 0xda46a90, 0xedfc210},
	{0xedfc210, 0xef92cd0, 0xfc876b0},
	{0xfc876b0, 0xfdb51b0, 0x11a7fab0},
	{0x128476b0, 0x12ea5db0, 0x1468e6b0},
	{0x11a7fab0, 0x12649e30, 0x128476b0},
	{0x16763db0, 0x1683b030, 0x1821ba30},
	{0x1821ba30, 0x18361850, 0x19fd91c0},
	{0x1468e6b0, 0x149800b0, 0x155a68b0},
	{0x155a68b0, 0x158ed230, 0x16763db0},
	{0x19fd91c0, 0x1a0e6dc0, 0x1ad1dc40},
};

char bgmfile[21][13]={
	"th08_01.wav",
	"th08_02.wav",
	"th08_03.wav",
	"th08_04.wav",
	"th08_05.wav",
	"th08_06.wav",
	"th08_07.wav",
	"th08_08.wav",
	"th08_09.wav",
	"th08_10.wav",
	"th08_11.wav",
	"th08_12.wav",
	"th08_13.wav",
	"th08_14.wav",
	"th08_15.wav",
	"th08_16.wav",
	"th08_17.wav",
	"th08_18.wav",
	"th08_19.wav",
	"th08_20.wav",
	"th08_21.wav",
};


void makeheader(char *header,int datasize){
	int i;
	short s;
	memcpy(header,"RIFF",4);
	i = datasize + 36;
	memcpy(header+4,&i,4);
	memcpy(header+8,"WAVEfmt ",8);
	i = 16;
	memcpy(header+16,&i,4);
	s = 1;
	memcpy(header+20,&s,2);
	s = 2;
	memcpy(header+22,&s,2);
	i = 44100;
	memcpy(header+24,&i,4);
	i = 176400;
	memcpy(header+28,&i,4);
	s = 4;
	memcpy(header+32,&s,2);
	s = 16;
	memcpy(header+34,&s,2);
	memcpy(header+36,"data",4);
	i = datasize;
	memcpy(header+40,&i,4);
	
}

int main(int argc,char *argv[]){
	FILE *datf,*bgmf;
	int i,j,l,k;
	int rep=2;
	int length;
	int fade=0;
	int fadep=0;
	int ts=0;
	int te=21;
	char header[44];
	short buf[44100*2];
	int s,e;
	double d;
	
	//bgmtable(JnAJԂn_܂ł̒AI_܂ł̒)Ȃ̂
	//ꂼʒuɊZ
//	for(i=0;i<7;i++){
//		bgmtable[i][1]+=bgmtable[i][0];
//		bgmtable[i][2]+=bgmtable[i][0];
//	}
	
	//argc̃`FbN
	for(i=1;i<argc;i++){
		switch(argv[i][0]){
		case 'f' :
			argv[i]++; fade=atoi(argv[i]); break;
		case 'F' :
			argv[i]++; fade=-atoi(argv[i]); break;
		case 'P' :
		case 'p' :
			argv[i]++; fadep=atoi(argv[i]); break;
		case 'T' :
		case 't' :
			argv[i]++; ts=te=atoi(argv[i]); break;
		default:
			rep=atoi(argv[i]);
		}
	}
	
	if(rep<1 || rep>10){
		printf("repeat must be 1-10\n");
		return 0;
	}
	if(fade<-30 || fade>30){
		printf("fade must be 0-30\n");
		return 0;
	}
	if(fadep<0 || fadep>3){
		printf("fade pattern must be 0-3\n");
		return 0;
	}
	if(ts<0 || te>21){
		printf("track number must be 1-7\n");
		return 0;
	}
		
	
	printf("track=%d-%d , repeat=%d , fade=%d , fade pattern=%d\n",ts,te,rep,fade,fadep);
	if(ts) ts--;
	
	datf=fopen("thbgm.dat","rb");
	if(datf==NULL){
		printf("thbgm.dat not found.");
		return 0;
	}
	
	//Jn
	for(i=ts;i<te;i++){
		
		printf("Create %s ...\n",bgmfile[i]);
		bgmf=fopen(bgmfile[i],"wb");
		length=(bgmtable[i][2]-bgmtable[i][0])+(bgmtable[i][2]-bgmtable[i][1])*(rep-1);
		if(fade<0) length+=(-fade)*44100*4;
		makeheader(header,length);
		fwrite(header,1,44,bgmf);
		
		//[v
		for(k=0;k<rep;k++){
			//[
			s=bgmtable[i][1];
			if(k==0) s=bgmtable[i][0];
			
			//I[
			e=bgmtable[i][2];
			if(k==rep-1 && fade>0) e=bgmtable[i][2]-fade*44100*4;
			
			for(j=s;j<e;j+=44100*4){
				if(j+44100*4>e) l=e-j;
				else l=44100*4;
				
				fseek(datf,j,SEEK_SET);
				fread(buf,1,l,datf);
				fwrite(buf,1,l,bgmf);
			}
		}
		
		//tF[hAEg
		if(fade>0){
			//[vI[
			s=bgmtable[i][2]-fade*44100*4;
			e=bgmtable[i][2];
		}
		else if(fade<0){
			//[v[
			s=bgmtable[i][1];
			e=s-fade*44100*4;
		}
		else{
			s=e=0;
		}
			
		for(j=s;j<e;j+=44100*4){
			if(j+44100*4>e) l=e-j;
			else l=44100*4;
			
			fseek(datf,j,SEEK_SET);
			fread(buf,1,l,datf);
			for(k=0;k<l/4;k++){
				switch (fadep) {
				case 0 :
					d=(float)((j-s)/4+k)/(abs(fade)*44100);
					d=pow(0.001,d);
					break;
				case 1 :
					d=1-(float)((j-s)/4+k)/(abs(fade)*44100);
					break;
				case 2 :
					d=(float)((j-s)/4+k)/(abs(fade)*44100);
					d=(pow(0.001,d)+(1-d))/2;
					break;
				case 3 :
					d=(cos(3.1415926535*(float)((j-s)/4+k)/(abs(fade)*44100))+1)/2;
					break;
				}
				
				buf[2*k]=(short)(buf[2*k]*d);
				buf[2*k+1]=(short)(buf[2*k+1]*d);
			}
			fwrite(buf,1,l,bgmf);
		}
		
		fclose(bgmf);
	}
	fclose(datf);
	
	return 0;
}


